
require 'sketchup.rb'

require 'wxSketchup'
include Wx

#
# Dialog subclass. Uses XRC for the dialog definition
#
class PluginDialog < Wx::Dialog

	def initialize (app, title)
        super(app, -1, title, Point.new(200,200))

		evt_button(ID_HELP) {|event| on_help(event) }
	end


	def get_control(id)
		return Wx::Window.find_window_by_id(id,self)
	end

	def set_text_value(id, value)
		a_control = Wx::Window.find_window_by_id(id,self)
		if (a_control == nil)
			printf( "No control named %s\n", id)
			return
		end
		a_control.set_value(value.to_s)
	end

	def get_text_value(id)
		a_control = Wx::Window.find_window_by_id(id,self)
		return a_control.get_value()
	end

	def set_radiobox_index(id, value)
		a_control = Wx::Window.find_window_by_id(id,self)
		a_control.set_selection(value)
	end

	def get_radiobox_index(id)
		a_control = Wx::Window.find_window_by_id(id,self)
		sel = a_control.get_string_selection()
		# assume radioboxes go from 0 to a positive integer
		idx = 0
		while (1)
			str = a_control.get_string(idx)
			if (str == nil)
				return -1
			end
			if (str == sel)
				return idx;
			end
			idx = idx + 1
		end
	end

	def set_help_dialog(xrc_file, dialog_id)
		@help_xrc_file = xrc_file
		@help_dialog_id = dialog_id
	end

	def on_ok(event)
		end_modal(Wx::ID_OK)
	end

	def on_cancel(event)
		end_modal(Wx::ID_CANCEL)
	end

	def on_help(event)
		if (@help_xrc_file == nil)
			Wx::message_box("No help available", "Default Help")
		else
			help_dialog = PluginDialog.new(@app)
			help_dialog.load (@help_xrc_file, @help_dialog_id)
			help_dialog.show_modal();
		end
	end

end


#
# simple app for running Sketchup plugin dialogs
# wxDialog code requires a wxApp to work correctly
#
class PluginApp < Wx::App

	@@frame = nil
	@xml = nil

    def init_frame()
		# create a proxy frame of the Sketchup application window
		if (@@frame == nil)
			@@frame = Frame.new(nil, -1, "Windows dialogs example", Point.new(20, 20), Size.new(400, 300), Wx::FRAME_PROXY)
		end
		set_top_window(@@frame)
	end
end